#!/bin/perl

@path = ();
$cur = 0;
$nxt = 0;
%joints = {};
%sites = {};
%alias = {};
$parents = {};
$site = "";


my $trailing_humanoid = "";


sub printXML {
	my($prev) = @_;  # $prev is $child
	$prev->{line} =~ /([ |]*)(.*) : (.*)/;
	my $parent_indent = length($1);
	my $parent_joint = $2;
	my $parent_segment = $3;
	my $nxt = length($1);
	# print "$1$2 : $3\n";
	my $cur = @path[@path-1];
	while ($nxt < $cur) {
		$cur = pop @path;
	}

	undef ($htrans);
	if ($parent_joint eq "l_talocrural") {
		$htrans =  "<Transform scale='0.15 0.15 0.15' translation='0.08 0.06 -0.025' rotation='1 0 0 -1.57'> <!-- Transform left foot -->\n";
		$htrans .= "<Transform> <!-- Empty Transform left foot -->\n";
		$dopaw = 1;
	} elsif ($parent_joint eq "r_talocrural") {
		$htrans = "<Transform scale='0.15 0.15 0.15' translation='-0.05 0.06 -0.025' rotation='1 0 0 -1.57'><!-- Transform right foot -->\n";
		$htrans .= "<Transform> <!-- Empty Transform right foot -->\n";
		$dopaw = 1;
	} elsif ($parent_joint eq "l_radiocarpal") {
		$htrans = "<Transform scale='0.2 0.2 0.2' translation='0.20 0.85 -0.05' rotation='0 0 1 -3.14'> <!-- Transform left hand -->\n";
		$htrans .= "<Transform rotation='0 1 0 -1.57'> <!-- Transform left hand -->\n";
		$dopaw = 1;
	} elsif ($parent_joint eq "r_radiocarpal") {
		$htrans = "<Transform scale='0.2 0.2 0.2' translation='-0.20 0.85 -0.05' rotation='0 0 1 -3.14'> <!-- Transform right hand -->\n";
		$htrans .= "<Transform rotation='0 1 0 1.57'> <!-- Transform right hand -->\n";
		$dopaw = 1;
	} else {
		$dopaw = 0;
	}

	{


		$trailing_humanoid .= "<HAnimJoint USE='hanim_".$parent_joint."' containerField='joints'/>\n";
		print " " x $nxt."<HAnimJoint DEF='hanim_".$parent_joint."' name='".$parent_joint."'";
		if ($nxt <= 1) {
			print " " x $nxt." containerField='skeleton'"
		}
		if ($joints{$parent_joint} ne "") {
			$cenpj = $joints{$parent_joint};
		} else {
			$cenpj = "0 1 0";
		}
		print " center='".$cenpj."'>\n";
		foreach my $ch (@{$prev->{children}}) {   # go through child segments

			$prev->{line} =~ /([ |]*)(.*) : (.*)/; # parent joint
			$parent_indent = length($1);
			$parent_joint = $2;
			$parent_segment = $3;

			$ch->{line} =~ /([ |]*)(.*) : (.*)/; # child joint
			$child_indent = length($1);
			$child_joint = $2;
			$child_segment = $3;

			if ($joints{$child_joint} ne "") {
				$cencj = $joints{$child_joint};
			} else {
				$cencj = "0 1 0";
			}
			$points = $joints{$parent_joint}." ".$cencj;
			if ($points =~ /^ /) {
				$verts = 1;
			} else {
				$verts = 2;
			}
		}
		foreach my $jnt (@{$prev->{children}}) {   # go through child joints
			&printXML($jnt);
		}
		print " " x $nxt."</HAnimJoint>\n";
	}
	if ($nxt >= $cur) {
		push @path, $nxt;
	}
}

open(TABLE, "sh sed.sh|");

while(<TABLE>) {
	chomp;
	$joint = $_;
	$center = <TABLE>;
	chomp $center;
	$joints{$joint} = $center;
}

foreach my $joint (sort keys %joints) {
	# print "TABLE ".$joint." ".$joints{$joint}."\n";
}

close(TABLE);

open(FEATURE, "<B.2.txt");

while(<FEATURE>) {
	chomp;
	if ($_ =~ /[^<>]*<tr>[^<>]*<td>([^<>]*)<\/td>[^<>]*<td>([^<>]*)<\/td>[^<>]*<td>([^<>]*)<\/td>[^<>]*<td>([^<>]*)<\/td>[^<>]*<td>([^<>]*)<\/td>[^<>]*<\/tr>[^<>]*/) {
		# print $2."\t|".$5."\n";
		$site = $2;
		$site_alias = $5;
		$site =~ s/[\t ]*([^\t ]*)[\t ]*/$1/;
		$site_alias =~ s/[\t ]*([^\t ]*)[\t ]*/$1/;
		$alias{$site_alias} = $site;
		# print "Alias $site_alias\n";
	}
}

close(FEATURE);

open(SITETABLE, "sh sitesed.sh|");

while(<SITETABLE>) {
	chomp;
	$site = $_;
	$translation = <SITETABLE>;
	chomp $translation;
	$sites{$site} = $translation;

	if ($alias{$site}) {
		# print "Found ".%alias{$site}." ".$translation."|\n";
		$sites{%alias{$site}} = $translation;
	} else {
		# print "No alias found for ".$site."\n";
	}
}
close(SITETABLE);

foreach my $site (sort keys %sites) {
	# print "SITE ".$site." ".$sites{$site}."\n";
}


open(SITESEG, "<4.7.txt");

$col = 0;
@sites = ();

$LOA = 4;

# LOA-4 maps to column 2
# LOA-3 maps to column 3
# LOA-2 maps to column 4
# LOA-1 maps to column 5
# LOA-0 maps to column 6

$loacol = 6 - $LOA;

while (<SITESEG>) {
	chomp;
	$line = $_;
	$line =~ s/[ \t]*([^ \t]*)[ \t]*/$1/e;
	# print $line."\n";
	if ($line eq "</table>") {
		break;
	} elsif ($line eq "<tr>") { # start a row
		$col = 0;
	} elsif ($line eq "</tr>") { # end a row
	} elsif ($line =~ /<td>(.*)<\/td>/) {
		$value = $1;
		if ($col == 0) {
			$row = $1;
			@sites[$row] = ();
			# print $row;
		} elsif ($col == 1) {
			@row = @sites[$row];
			@row[$col] = $value;
			# print " ".$value;
			$site = $value;  # site
		} elsif ($col == $loacol)  {
			@row = @sites[$row];
			@row[$col] = $value;
			# print " ".$value;
			my $segment = $value;
			$parents{$site} = $segment; # parent of site is segment
		}
		if ($col == 6)  {
			# print "\n";
		}
		$col++;
	}
}

# foreach my $site (keys %parents) {
# print $parents{$site}." ".$site."\n";
# }

close(SITESEG);

sub readHierarchy {
	open (HIER, "<Hierarchy.txt");
	my $prev = {};
	$prev->{children} = ();
	$prev->{indent} = -1;
	foreach (<HIER>) {
		$line = $_;
		chomp $line;
		$line =~ /([ |]*)(.*) : (.*)/;
		$indent = length($1);
		$joint = $2;
		$segment = $3;
		$obj = {};
		$obj->{line} = $line;
		$obj->{indent} = $indent;
		$obj->{joint} = $joint;
		$obj->{segment} = $segment;
		$obj->{children} = ();
		# print "$line\n";
		if ($obj->{indent} > $prev->{indent}) {
			$obj->{parent} = $prev;
			# print "$obj->{joint} parent 1 is $prev->{joint}\n";
		} elsif ($obj->{indent} == $prev->{indent}) {

			$obj->{parent} = $prev->{parent};
			# print "$obj->{joint} parent 2 is $prev->{parent}->{joint}\n";
		} else {
			while ($obj->{indent} < $prev->{indent}) {
				$prev = $prev->{parent};
			}
			$obj->{parent} = $prev->{parent};
			# print "$obj->{joint} parent 3 is $prev->{joint}\n";
		}
		push @{$obj->{parent}->{children}}, $obj;
		$prev = $obj;
	}
	while (0 < $prev->{indent}) {
		$prev = $prev->{parent};
	}
	close(HIER);
	return $prev;
}

print << "HUMANHEADER";
<?xml version="1.0" encoding="UTF-8"?>
<!DOCTYPE X3D PUBLIC "ISO//Web3D//DTD X3D 4.0//EN" "https://www.web3d.org/specifications/x3d-4.0.dtd">
<X3D profile="Immersive" version="4.0" xmlns:xsd="http://www.w3.org/2001/XMLSchema-instance" xsd:noNamespaceSchemaLocation="https://www.web3d.org/specifications/x3d-4.0.xsd">
<head>
  <component level='1' name='HAnim'/>
  <meta content='JohnBoy.x3d' name='title'/>
  <meta name='identifier' content='http://www.web3d.org/x3d/content/examples/HumanoidAnimation/JohnBoy.x3d'/>
  <meta name='description' content='An attempt at a standard LOA-4 skeleton'/>
  <meta name='generator' content='h2.pl'/>
  <meta name='modified' content="14 Jan 2023/>
  <meta content='John Carlson' name='creator'/>
  <meta content='9 November 2020' name='created'/>
  <meta content='../license.html' name='license'/>
</head>
<Scene>

  <Transform scale='1 1 1'> <!-- DEF for markerfor XYZ axes -->
   <Shape DEF='AxisLinesShape'> <!-- RGB lines showing XYZ axes -->
    <IndexedLineSet colorIndex='0 1 2' colorPerVertex='false' coordIndex='0 1 -1 0 2 -1 0 3 -1'>
     <Coordinate point='0 0 0 0.1 0 0 0 0.1 0 0 0 0.1'/>
     <Color color='1 0 0 0 0.6 0 0 0 1'/>
    </IndexedLineSet>
   </Shape>
  </Transform>
 
<Group> <!-- DEFS for markers of skeleton joints, segments, and sites --> 
 <Transform translation='0 0 0' scale='1 1 1'>
<!--
  <Transform translation='0 2 0' scale='1 1 1'>
   <Shape DEF='HAnimRootShape'>
    <Sphere radius='0.02'  />
     <Appearance>
      <Material DEF='HAnimRootMaterial' diffuseColor='0.8 0 0' transparency='0.3'/>
     </Appearance>
    </Shape>
  </Transform>
  -->
  <Transform translation='0 2.1 0' scale='1 1 1'>
   <Shape DEF='HAnimJointShape'>
    <Sphere radius='0.02' />
     <Appearance>
      <Material DEF='HAnimJointMaterial' diffuseColor='0 0 0.8' transparency='0.3'/>
       </Appearance>
   </Shape>
  </Transform>
  <Transform translation='0 2.05 0' scale='1 1 1'>
   <Shape DEF='HAnimSegmentLine'>
    <LineSet vertexCount='2'>
     <ColorRGBA DEF='HAnimSegmentLineColorRGBA' color='1 1 0 1 1 1 0 0.1'/>
      <Coordinate point='-0.05 0 0 0.05 0 0'/>
       </LineSet>
    </Shape>
  </Transform>
<!--
  <Transform translation='0 2.1 0' scale='1 1 1'>
   <Shape DEF='HAnimSiteShape'>
    <IndexedFaceSet DEF='DiamondIFS' creaseAngle='0.5' solid='false' coordIndex='0 1 2 -1 0 2 3 -1 0 3 4 -1 0 4 1 -1 5 2 1 -1 5 3 2 -1 5 4 3 -1 5 1 4 -1'>
     <ColorRGBA DEF='HAnimSiteColorRGBA' color='1 1 0 1 1 1 0 0.1'/>
     <Coordinate point='0 0.01 0 -0.01 0 0 0 0 0.01 0.01 0 0 0 0 -0.01 0 -0.01 0'/>
    </IndexedFaceSet>
     <Appearance>
      <Material diffuseColor='1 1 0' transparency='0.3'/>
     </Appearance>
   </Shape>
  </Transform>
  -->
 </Transform>
</Group> 

<NavigationInfo speed='1.5' type='"EXAMINE" "ANY"'/>

<Viewpoint centerOfRotation='0 0 0' description='default'/> 

<HAnimHumanoid DEF='hanim_HAnim'  info='"humanoidVersion=2.0"' name='HAnim' scale='1 1 1' translation='0 0 0' version='2.0'>
HUMANHEADER
my $prev = &readHierarchy();
&printXML($prev);
print $trailing_humanoid;
print << "HUMANFOOTER";
</HAnimHumanoid>
</Scene>
</X3D>
HUMANFOOTER

sub printNode {
	my($top, $indent) = shift @_;
	print $top->{line}."\n";
	foreach my $child (@{$top->{children}}) {
		&printNode($child);
	}
}

# &printNode($prev);
